// Startovn slo 14

unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls;

type TMesto = record
    nazev : string;
    polohaX : integer;
    polohaY : integer;
    I : integer;
end;

type TCesta = record
    z : string;
    kam : string; // do - klov slovo :-(
    vzdalenost : integer;
    prumernarychlost : integer;
end;

type TSpotreba = record
    rychlost : integer;
    litru : real;
end;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Label1: TLabel;
    Edit1: TEdit;
    Button1: TButton;
    OpenDialog1: TOpenDialog;
    Button2: TButton;
    Panel2: TPanel;
    Panel3: TPanel;
    Image1: TImage;
    Button3: TButton;
    ListBox1: TListBox;
    Panel4: TPanel;
    CheckBox1: TCheckBox;
    StatusBar1: TStatusBar;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    function NajdiMesto(mesto :string):integer;
    procedure ListBox1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  PMesta: array of TMesto;
  PCesty: array of TCesta;
  PSpotreby: array of TSpotreba;
  mapa: bool = false;
  mesta: bool = false;
  mesto: bool = false;
  cesty: bool = false;
  cesta: bool = false;
  spotreby: bool = false;
  spotreba: bool = false;
  rozsirM: bool = true;
  rozsirC: bool = true;
  rozsirS: bool = true;
  ChciCesty: bool = true;
implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
begin
if opendialog1.Execute then
  begin
  edit1.Text := opendialog1.FileName;
  end;
end;

procedure TForm1.Button2Click(Sender: TObject);
var soubor : TextFile;
radka : string; // prv spracovvan dka
begin
if fileexists(edit1.Text) then
  begin
  assignfile(soubor,edit1.Text);
  reset(soubor);
  while not eof(soubor) do
    begin
    readln(soubor,radka);
    if pos('<?',radka) <= 0 then // pesko hlaviku
      begin
      if pos('<mapa>',radka) > 0 then mapa := true;
      if pos('<mesta>',radka) > 0 then mesta := true;
      if pos('<mesto>',radka) > 0 then mesto := true;
      if pos('<cesty>',radka) > 0 then cesty := true;
      if pos('<cesta>',radka) > 0 then cesta := true;
      if pos('<spotreby>',radka) > 0 then spotreby := true;
      if pos('<spotreba>',radka) > 0 then spotreba := true;

      if mapa = true then
        begin
        if mesta = true then
          begin
          if mesto = true then
            begin
            if rozsirM then
              begin
              setlength(PMesta,length(PMesta)+1);
              rozsirM := false;
              end;
            if pos('<nazev>',radka) > 0 then
              begin
              PMesta[high(PMesta)].nazev := copy(radka,pos('<nazev>',radka)+7,pos('</nazev>',radka)-7-pos('<nazev>',radka));
              end
            else if pos('<polohaX>',radka) > 0 then
              begin
              PMesta[high(PMesta)].polohaX := round(1.8*strtoint(copy(radka,pos('<polohaX>',radka)+9,pos('</polohaX>',radka)-9-pos('<polohaX>',radka))));
              end
            else if pos('<polohaY>',radka) > 0 then
              begin
              PMesta[high(PMesta)].polohaY := round(1.8*strtoint(copy(radka,pos('<polohaY>',radka)+9,pos('</polohaY>',radka)-9-pos('<polohaY>',radka))));
              rozsirM := true;

              end;
            end; // mesto
          end; // mesta
        if cesty = true then
          begin
          mesta := false;
          if cesta = true then
            begin
            if rozsirC then
              begin
              setlength(PCesty,length(PCesty)+1);
              rozsirC := false;
              end;
            if pos('<z>',radka) > 0 then
              begin
              PCesty[high(PCesty)].z := copy(radka,pos('<z>',radka)+3,pos('</z>',radka)-3-pos('<z>',radka));
              end
            else if pos('<do>',radka) > 0 then
              begin
              PCesty[high(PCesty)].kam := copy(radka,pos('<do>',radka)+4,pos('</do>',radka)-4-pos('<do>',radka));
              end
            else if pos('<vzdalenost>',radka) > 0 then
              begin
              PCesty[high(PCesty)].vzdalenost := strtoint(copy(radka,pos('<vzdalenost>',radka)+12,pos('</vzdalenost>',radka)-12-pos('<vzdalenost>',radka)));
              end
            else if pos('<prumernaRychlost>',radka) > 0 then
              begin
              PCesty[high(PCesty)].prumernaRychlost := strtoint(copy(radka,pos('<prumernaRychlost>',radka)+18,pos('</prumernaRychlost>',radka)-18-pos('<prumernaRychlost>',radka)));
              rozsirC := true;
              end;
            end;
          end; // cesty
        end; // mapa
      end;
    end;
  closefile(soubor);
  Button2.Enabled := false;
  Button3.Enabled := true;
  showmessage('Soubor byl spn naten, nyn mete msta a cesty vykreslit.');
  end
else showmessage('Chybn zadan soubor !');
end;

function TForm1.NajdiMesto(mesto :string):integer;
var i : integer;
begin
for i := 0 to high(PMesta) do
  begin
  if PMesta[i].nazev = mesto then NajdiMesto := i;
  end;
end;

procedure TForm1.Button3Click(Sender: TObject);
var i,Z,Kam: integer;
begin
for i := 0 to high(PMesta) do // vykresl a zape msta
  begin
  ListBox1.Items.Add(PMesta[i].nazev);
  Image1.Canvas.Brush.Color := clBlack;
  Image1.Canvas.Ellipse(PMesta[i].polohaX-2+100,PMesta[i].polohaY-2+150,PMesta[i].polohaX+2+100,PMesta[i].polohaY+2+150);
  Image1.Canvas.Brush.Color := clWhite;
  end;
if ChciCesty then
  begin
  for i := 0 to high(PCesty) do
    begin
    Image1.Canvas.Brush.Color := clblack;
    Image1.Canvas.MoveTo(PMesta[najdimesto(PCesty[i].z)].polohaX+100,PMesta[najdimesto(PCesty[i].z)].polohaY+150);
    Image1.Canvas.LineTo(PMesta[najdimesto(PCesty[i].kam)].polohaX+100,PMesta[najdimesto(PCesty[i].kam)].polohaY+150);
    end;
  end;
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
ChciCesty := CheckBox1.Checked;
Image1.Canvas.Brush.Color := clWhite;
Image1.Canvas.FillRect(Image1.ClientRect);
Button3Click(self);
end;

procedure TForm1.ListBox1Click(Sender: TObject);
var mesto,text : string;
i : integer;
begin
mesto := ListBox1.Items.Strings[ListBox1.ItemIndex];
for i := 0 to high(PCesty) do
  begin
  if PCesty[i].z = mesto then
    begin
    text := text + mesto + ' -> '+PCesty[i].kam + ' - '+inttostr(PCesty[i].vzdalenost)+ ' km' + ' za '+copy(floattostr(PCesty[i].vzdalenost / PCesty[i].prumernarychlost),1,3)+ ' h' + #10#13;
    end;
  end;
showmessage(text);
end;

end.
